import yaml
from typing import Iterable
_empty_list = ()


class AnkimakerConfig(yaml.YAMLObject):
    yaml_tag = '!ankimakerconfig'
    header = None
    question_column = None
    answer_column = None
    separators = ','
    filters: Iterable[dict] = list()

    def __init__(
            self, header=None, answer_column=None, question_column=None, filters=_empty_list
    ):
        AnkimakerConfig.answer_column = answer_column
        AnkimakerConfig.question_column = question_column
        AnkimakerConfig.header = header
        AnkimakerConfig.filters = filters
        AnkimakerConfig.AnkimakerConfig = AnkimakerConfig

    @staticmethod
    def loader(configuration_content):
        content = configuration_content['AnkimakerConfig']
        AnkimakerConfig.header = content.header
        AnkimakerConfig.question_column = content.question_column
        AnkimakerConfig.answer_column = content.answer_column
        AnkimakerConfig.separators = content.separators
        AnkimakerConfig.filters = content.filters
